---
title: Remotely debugging Thunderbird
slug: Tools/Remote_Debugging/Thunderbird
tags:
  - Debug
  - Tutorial
  - thunderbird
---
<div>{{ToolsSidebar}}</div><p>This guide explains how to use <a href="/en-US/docs/Mozilla/Firefox_OS/Firefox_OS_usage_tips/Remote_debugging">remote debugging </a>to inspect or debug code running in <a href="/en-US/docs/Mozilla/Thunderbird">Thunderbird</a>.</p>

<p>Various developer tools are supported by Thunderbird using the remote connection mechanism in Firefox. The currently supported toolset is the Web Console, Inspector, Debugger, Style Editor, Profiler and Network Monitor. Other Tools may become available in the future.</p>

<h2 id="Setting_up_Thunderbird">Setting up Thunderbird</h2>

<p>All that needs to be done in Thunderbird is enabling the debugger server. This can be done using <code>Tools</code> from the Menu Bar (alt + Tools) and selecting <code>Allow Remote Debugging</code>. By default, a debugger server will be started on port 6000. If you would like to change this port, for example to debug multiple profiles, you must open the advanced config editor and change the preference <code>devtools.debugger.remote-port</code>.</p>

<h2 id="Setting_up_Firefox">Setting up Firefox</h2>

<p>Firefox acts as the client and provides the user interface to control the developer tools for Thunderbird. It's best to use a Firefox and Thunderbird version with a matching major version number, but in some cases it will work even with differing versions.</p>

<p>To set up Firefox, remote debugging is enabled by a setting in the Toolbox. <a href="/en-US/docs/Tools_Toolbox">Open the Toolbox</a>, click the "Settings" button in the <a href="/en-US/docs/Tools_Toolbox#Toolbar">toolbar</a>, and check "Enable remote debugging" in the <a href="/en-US/docs/Tools_Toolbox#Settings">Settings </a>tab:</p>

<p><img alt="" src="https://mdn.mozillademos.org/files/5827/remote-debugger-toolbox-settings.png"></p>

<p>Now you can open the connection page in Firefox via the tools menu:</p>

<p><img alt="" src="https://mdn.mozillademos.org/files/5811/remote-debugging-connect-menuitem.png" style="height: 503px; width: 583px;"></p>

<p>A page will open in the browser; you can add this to your bookmarks toolbar if you like. In case you didn't change the remote port, the fields will already be filled out correctly. Click on the Connect button to initiate the developer tools remote connection.</p>

<p><img alt="" src="https://mdn.mozillademos.org/files/5813/remote-debugging-desktop-connect.png" style="height: 686px; width: 732px;"></p>

<p>Afterwards you will be presented with a list of remote tabs and processes. As Thunderbird's notion of tabs doesn't match Firefox, the remote tabs area shows all xul:browser elements in Thunderbird. This can be a content tab, or the message reader. In most cases you will want to select "Main Process" to debug the Thunderbird code itself. A new window opens containing a set of developer tools that can be used with your Thunderbird instance.</p>

<p><img alt="" src="https://mdn.mozillademos.org/files/5819/remote-debugging-desktop-select-target.png"></p>

<h2 id="Using_the_Developer_Tools">Using the Developer Tools</h2>

<p>Usage of the tools is mostly self explanatory. If you are having trouble with a certain tool, check the <a href="/en-US/docs/Tools/Remote_Debugging">Developer Tools documentation</a>. Due to a remote connection being used there might be some slight differences. Some tools might not be available, and it is also possible that performance is not comparable. For example, using the remote debugger tool takes quite some time to load because the files must be transferred over an internal network connection.</p>

<h2 id="Troubleshooting">Troubleshooting</h2>

<p>If you encounter an error, the first thing you should check is if you are using matching version numbers. If you are using Thunderbird 24, you should also use Firefox 24 to connect. Next, it important to figure out if it is a problem with the Firefox Developer Tools or with the remote connection code in Thunderbird. To verify this, please try to reproduce the problem using only Firefox. For example, if you notice that you cannot set an attribute value in the Inspector tool, try changing an attribute in the Browser Debugger in Firefox. If you cannot reproduce it there, file a bug in the Thunderbird product, otherwise file a bug in Firefox/Developer Tools.</p>
